#define BLOCK_SIZE 16
#define A_BLOCK_STRIDE (BLOCK_SIZE * a_width)
#define A_T_BLOCK_STRIDE (BLOCK_SIZE * a_height)

__kernel void mat_transp_2_kernel(
  __global float *a , 
  __global float *a_t,
  unsigned int a_width, 
  unsigned int a_height
)
{
  __local float a_local [BLOCK_SIZE*BLOCK_SIZE];
  int base_idx_a =
    get_group_id (0) * BLOCK_SIZE +
    get_group_id (1) * A_BLOCK_STRIDE;
  int glob_idx_a =
    base_idx_a + get_local_id (0)
    + a_width * get_local_id (1);

  a_local [ get_local_id (1)*BLOCK_SIZE + get_local_id (0)] = a [glob_idx_a];

  int base_idx_a_t =
    get_group_id (1) * BLOCK_SIZE +
    get_group_id (0) * A_T_BLOCK_STRIDE;
  int glob_idx_a_t =
    base_idx_a_t + get_local_id (0)
    + a_height * get_local_id (1);

  barrier (CLK_LOCAL_MEM_FENCE);
  a_t [glob_idx_a_t] = a_local [ get_local_id (0)*BLOCK_SIZE + get_local_id (1)];

}


